#!/bin/bash
VER="1.3"
########################################################################################
# Tur-AutoNuke by Turranius ( http://www.grandis.nu/glftpd/ ) turranius@hotmail.com    #
#-[ Introduction ]---------------------------------------------------------------------#
#                                                                                      #
# This is an autonuking script for empty folders and incompleted uploads.              #
# Read the README for a full list of options.                                          #
#                                                                                      #
#-[ Installation ]---------------------------------------------------------------------#
#                                                                                      #
# Copy this script to /glftpd/bin/ or where ever really. Make it executable.           #
# Read the README!                                                                     #
# Setup all the options below. Be careful unless you want the whole site nuked.        #
# !! Before running it the first time, use the variable test (tur-autonuke.sh test) !! #
#                                                                                      #
#-[ Changelog ]------------------------------------------------------------------------#
#                                                                                      #
# 1:3 : Add: Made a seperate README file for settings as it got too big.               #
#       Add: Added module "Half-Empty"                                                 #
#       Add: Added module "Banned words".                                              #
#            If you are upgrading, make sure to read the README as its alot of changes #
# 1.2 : Add: Pre-nuke warning added for empty folders too.                             #
#            Both empty dir pre-warnings and incomplete pre-warnings can now be        #
#            disabled separetly, instead of setting GLLOG=""                           #
# 1.1 : Add: It can now send a pre-nuke warning.                                       #
# 1.0 :      Initial release. Works fine.                                              #
#                                                                                      #
#-[ irc ]------------------------------------------------------------------------------#
#                                                                                      #
# Contact Turranius on Efnet. ( turranius / turran / turr|away / turr|work )           #
#                                                                                      #
#-[ Settings ]-------------------------------------------------------------------------#

#--[ Generic - See README for explanation ]--#
today="$( date +%m%d )"
yesterday="$( date --date "yesterday" +%m%d )"

GLROOT="/glftpd"
GLCONF="/etc/glftpd.conf"
GLLOG="/glftpd/ftp-data/logs/glftpd.log"  
LOG="/glftpd/ftp-data/logs/tur-autonuke.log"
TEMPDIR="/glftpd/tmp"

NUKEPROG="/glftpd/bin/nuker"
NUKEUSER="turranius"

DIRS="
/site/VCD
/site/XXX
/site/SVCD
/site/ISO-UTILS
/site/DIVX
/site/0DAYS/$today
/site/0DAYS/$yesterday
"

EXCLUDES="nfo.fix dirfix dir.fix GROUPS"


#---[ Totally empty module ]---#
TOTALLYEMPTY="TRUE"      # Check for empty folders at all?
PRENUKEEMPTY="TRUE"      # Send pre-nuke warning?
EARLYEMPTY="5"           # Minutes before sending a per-nuke warning.
TIMEEMPTY="20"           # Minutes before nuke.
EMPTYMULTIPLIER="3"      # Nuke multiplier


#---[ Half empty module ]---#
HALFEMPTY="TRUE"         # Check for "halfempty" folders at all?
PRENUKEHALFEMPTY="TRUE"  # Send pre-nuke warning?
EARLYHALFEMPTY="15"      # Minumum age to send pre-nuke warning.
TIMEHALFEMPTY="60"       # Minumum age to nuke.
HALFEMPTYMULTIPLIER="3"  # Nuke multiplier
EMPTYEXCLUDE=".zip .rar .r00 .r01 .mp3 .000 .001" # See README


#---[ Incomplete module ]---#
INCOMPLETE="TRUE"     # Use symlinks nukes at all? TRUE/FALSE
PRENUKEINCOM="TRUE"   # Send pre-nuke warning?
EARLYINCOM="100"      # Minutes before sending a pre-nuke warning. 
TIMEINCOM="200"       # Minumum age in minutes to nuke.
INCOMMULTIPLIER="3"   # Nuke multiplier
SYMLINKNAME="[incomplete]-"  # What does your symlinks contain.
CLEANSYMLINKS="TRUE"  # Remove "dead" symlinks? 
CLEANMESSAGE="FALSE"  # Clean .message file of incompletes?
JUMPON="CD1 CD2 CD3 CD4 CD5 CD6 CD7 Cd1 Cd2 Cd3 Cd4 Cd5 Cd6 Cd7" # See README


#---[ Banned words module ]---#
BANNEDWORDS="TRUE"   # Use banned words module at all? TRUE/FALSE.

BANDIRS="
/site/0DAYS/$today~.german:.french
/site/0DAYS/$yesterday~.german:.french
"

ALLOWED="Allowed"    # What makes it ok?
BANEXCLUDE="-OxYGeN -MYTH" # Special exclude for this module.
BANPRENUKE="TRUE"    # Send a pre-nuke warning?
EARLYBANPRENUKE="1"  # Minutes before I send pre-nuke warning?
TIMEBANNUKE="30"     # Minutes, before I nuke it?
BANMULTIPLIER="3"    # Multiplier to nuke for banned words.


#---[ Generics ]---#
SHWING="TRUE"          # Shwing it, magistern.
BOTTRIGGER="AUTONUKE:" # Trigger for your bot.


###########################################################################################
# Yadda Yadda, no changes below here, rip off balls etc etc.                              #
###########################################################################################

## Check date for the logfile.
DATENOW="$(date +%D" - "%T)"

## Nuked dir syntax. Dont want to nuke those again.
NUKES="$( grep nukedir_style $GLCONF | egrep -iv '#' | cut -f2-2 | awk -F"%" -F"-" '{print $1}' )"

if [ -e $LOG ]; then
  foundit=yes
else
  touch $LOG
  chmod 777 $LOG
fi

if [ "$SHWING" = "TRUE" ]; then
  echo "Read the instructions before running this!"
  exit 1
fi

if [ "$PRENUKEEMPTY" = "TRUE" -o "$PRENUKEINCOM" = "TRUE" -o "$PRENUKEHALFEMPTY" = "TRUE" -o "$BANNEDWORDS" = "TRUE" ]; then
  if [ -e "$GLLOG" ]; then
    foundit=yes
  else
    echo "You have early pre-nuke warnings enabled, but $GLLOG was not found."
    echo "Either fix GLLOG or set all pre-nuke warnings to FALSE."
    exit 1
  fi
fi


####################################################################################
## Totally empty folders check                                                     #
####################################################################################

if [ "$TOTALLYEMPTY" = "TRUE" ]; then
  
  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking empty folders ]-"
  fi

  for folders in $DIRS; do
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders  
    else
      echo "I can not find $GLROOT$folders - I'll quit here while you fix your mistake."
      echo "Check the DIRS= settings."
      exit 0
    fi

    if [ "$1" = "test" ]; then
      echo "--Entering $folders"
    fi
    for found in `find $GLROOT$folders -empty -type d -mmin +$TIMEEMPTY -maxdepth 1 -print | grep -vw "$NUKES" | grep -vx $GLROOT$folders | cut -b9-`; do
     if [ "$1" = "test" ]; then
       echo "Folder: $folders  Other: $found  Empty more then $TIMEEMPTY minutes. Nuking it (test)."
     fi
     FOUNDEMPTYNUKE="$folders"
     if [ "$1" != "test" ]; then
       $NUKEPROG -r $GLCONF -N $NUKEUSER -n {/$found} $EMPTYMULTIPLIER -Auto- Empty for more than $TIMEEMPTY minutes.
       echo "$DATENOW Nuke: /$found - Empty after $TIMEEMPTY minutes. $EMPTYMULTIPLIER Nuke." >> $LOG
     fi
    done

    ## Early Pre-Nuke warning
    if [ "$PRENUKEEMPTY" = "TRUE" ]; then
      for found in `find $GLROOT$folders -empty -type d -mmin +$EARLYEMPTY -maxdepth 1 -print | grep -vw "$NUKES" | grep -vx $GLROOT$folders | cut -b9-`; do
       if [ "$FOUNDEMPTYNUKE" != "$folders" ]; then
         REALEMPTYTMP="$( echo $found | tr -s '/' ' ' )"
         for o in $REALEMPTYTMP; do
         REALEMPTY="$o"
         done
         EMPTYPROCESS="TRUE"
         if [ "$1" = "test" ]; then
           if [ -e "$TEMPDIR/prewarnedempty.$REALEMPTY" ]; then
             echo "Folder: $folders  Other: $REALEMPTY empty more then $EARLYEMPTY minutes. Already sent Pre-warning though (test)."
             echo "  -Remove $TEMPDIR/prewarnedempty.$REALEMPTY to send again."
           else
             echo "Folder: $folders  Other: $REALEMPTY empty more then $EARLYEMPTY minutes. Sending pre-nuke warning (test)."
             echo "Prewarning" > $TEMPDIR/prewarnedempty.$REALEMPTY
           fi
         fi
         if [ "$1" != "test" ]; then
           if [ -e "$TEMPDIR/prewarnedempty.$REALEMPTY" ]; then
             EMPTYPROCESS="TRUE"
           else
             echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $REALEMPTY\002 is still empty after $EARLYEMPTY minutes. Will be nuked when its \002$TIMEEMPTY\002 minutes old." >> $GLLOG
             echo "$DATENOW Nuke: /$found - Pre-nuke warning (empty) sent. More then $EARLYEMPTY minutes." >> $LOG
             echo "Prewarning" > $TEMPDIR/prewarnedempty.$REALEMPTY
           fi
         fi
       fi
      FOUNDEMPTYNUKE=""
      done
    fi
  done
fi


####################################################################################
## Half empty module                                                               #
####################################################################################

if [ "$HALFEMPTY" = "TRUE" ]; then

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking half-empty folders ]-"
  fi

  ## Make a | between excluded folders.
  EXCLUDESPECIAL="$( echo $EXCLUDES | tr -s ' ' '|' )"
  ## Add the nuked syntax to it too.
  EXCLUDESPECIAL="$EXCLUDESPECIAL|$NUKES"

  for folders in $DIRS; do
    if [ "$1" = "test" ]; then
      echo "--Entering $folders"
    fi
 
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders
    else
      echo "I can not find $GLROOT$folders - I'll quit here while you fix your mistake."
      echo "Check the DIRS= settings."
      exit 0
    fi

    for them in `ls -L | egrep -iv $EXCLUDESPECIAL`; do
      #echo "Checking $them"
      if [ -e $TEMPDIR/tur-autonuke.index ]; then
        INDEX="$( cat $TEMPDIR/tur-autonuke.index | grep -w $them )"
      else
        if [ "$1" = "test" ]; then
          echo "Since this seems to be the first time you run the half-empty module, I"
          echo "will now build the index file to speed it up next time its run."
          echo "I will also check for half-empty folders while I'm at it."
          echo "This can take a while, and will only happen once."
          echo ""
        fi
      fi
      if [ "$INDEX" = "" ]; then
        GOTTHROUGH="TRUE"
        for content in `ls -LR $them`; do
          if [ "$GOTFILE" != "TRUE" ]; then
            for excludes in $EMPTYEXCLUDE; do
              if [ "$GOTFILE" != "TRUE" ]; then
                if [ "$ALREADYFOUND" != "TRUE" ]; then
                  VERIFY="$( echo $content | grep -i $excludes )"
                  #echo "$them - echoing $content and grepping $excludes"
                  if [ "$VERIFY" != "" ]; then
                    #echo "VERIFY: $VERIFY found from $them"
                    ALREADYFOUND="TRUE"
                    echo "$them" >> $TEMPDIR/tur-autonuke.index
                  fi
                  if [ "$VERIFY" != "" ]; then
                    GOTFILE="TRUE"
                  fi
                fi
              fi
            done
          fi
        done
      fi
      if [ "$GOTFILE" != "TRUE" ]; then
        if [ "$GOTTHROUGH" = "TRUE" ]; then
          for found in `find $GLROOT$folders/$them -type d -mmin +$TIMEHALFEMPTY -maxdepth 0 -print | grep -vw "$NUKES" | grep -vx $them | cut -b9-`; do
            if [ "$1" = "test" ]; then
              echo "$folders/$them seems empty and is older then $TIMEHALFEMPTY mins. Nuking! (test)"
            else
              $NUKEPROG -r $GLCONF -N $NUKEUSER -n {$folders/$them} $HALFEMPTYMULTIPLIER -Auto- Empty for more then $TIMEHALFEMPTY minutes
              echo "$DATENOW Nuke: $folders/$them - Half-empty after $TIMEHALFEMPTY minutes. $HALFEMPTYMULTIPLIER Nuke." >> $LOG
            fi
            HALFEMPTY="TRUE"
          done
          if [ "$HALFEMPTY" != "TRUE" ]; then
            for found in `find $GLROOT$folders/$them -type d -mmin +$EARLYHALFEMPTY -maxdepth 0 -print | grep -vw "$NUKES" | grep -vx $them | cut -b9-`; do
              if [ -e "$TEMPDIR/prewarnedalmostempty.$them" ]; then
                if [ "$1" = "test" ]; then
                  echo "$folders/$them seems empty. Pre nuke warning already sent (test)"
                fi
              else
                if [ "$1" = "test" ]; then
                  if [ "$PRENUKEHALFEMPTY" = "TRUE" ]; then
                    echo "$folders/$them seems empty. Sending pre-nuke warning (test)"
                  fi
                  echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarnedalmostempty.$them
                else
                  if [ "$PRENUKEHALFEMPTY" = "TRUE" ]; then
                    echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $them\002 Empty or incomplete after $EARLYHALFEMPTY minutes. Will be nuked when its \002$TIMEHALFEMPTY\002 minutes old." >> $GLLOG
                    echo "$DATENOW Nuke: $folders/$them - Half-empty after $EARLYHALFEMPTY minutes. Pre-nuke warning sent." >> $LOG
                    echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarnedalmostempty.$them
                  fi
                fi
              fi
            done
          fi
          HALFEMPTY=""
          HALFPROCESS="TRUE"
        else
          CORE="YES"
          #echo "$them already checked"
        fi
      fi
      GOTTHROUGH=""
      GOTFILE="FALSE"
      HALFEMPTY=""
      ALREADYFOUND="FALSE"
      them=""
    done
      them=""
  done
fi


############################################################################
# Checking incompleted releases by symlink.                                #
############################################################################

if [ "$INCOMPLETE" = "TRUE" ]; then
  
  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking incompletes ]-"
  fi

  for folders in $DIRS; do
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders
    else
      echo "I can not find $GLROOT$folders - Quitting until you fix this."
      exit 0
    fi

    if [ "$1" = "test" ]; then
      echo "--- Entering $folders"
    fi
    LIST="$( ls -m )"

    for dirs in $LIST; do
      VERIFY="$( echo $dirs | grep -F $SYMLINKNAME )"
      if [ "$VERIFY" != "" ]; then
        VERIFY="$( echo $VERIFY | tr -d ',' )"
        if [ "$1" = "test" ]; then
          echo "Found incomplete link: $VERIFY"
        fi
        CHECK="$( ls -l $GLROOT$folders | grep -F $VERIFY )"
        CHECK="$( echo $CHECK | awk -F ">" '{print $2}' | tr -s '/' ' ' )"
        for crap in $CHECK; do
          LAST="$REALNAME"
          REALNAME="$crap"
        done
        for jump in $JUMPON; do
          if [ "$REALNAME" = "$jump" ]; then
            REALNAME="$LAST"
          fi
        done

        if [ -e "$REALNAME" ]; then
          for folder in `find $REALNAME -type d -mmin +$TIMEINCOM -maxdepth 1 -print | grep -vw "$NUKES" | grep -vx $REALNAME | cut -b9-`; do
            if [ "$REALNAME" != "$LAST" ]; then
              EXCLUDE="NO"
              for excludes in $EXCLUDES; do
                VERIFY2="$( echo $REALNAME | grep -i $excludes )"
                if [ "$VERIFY2" != "" ]; then
                  EXCLUDE="YES"
                fi
              done

              if [ "$EXCLUDE" != "YES" ]; then
                if [ "$1" = "test" ]; then
                  echo "$REALNAME is older then $TIMEINCOM minutes. Nuking it (test)."
                fi

                if [ "$CLEANMESSAGE" = "TRUE" ]; then
                  if [ -e $GLROOT/$folders/.message ]; then
                    if [ "$1" = "test" ]; then
                      CHECKMESSAGE="$( cat $GLROOT/$folders/.message | grep -w $REALNAME )"
                      echo "Removing release from .message (test, line follows below:)"
                      echo "$CHECKMESSAGE"
                    else
                      cat $GLROOT/$folders/.message | grep -v "$REALNAME" > $TEMPDIR/message.tmp
                      mv -f $TEMPDIR/message.tmp $GLROOT/$folders/.message
                      echo "Actually removed it from .message"
                    fi
                  else
                    echo "CLEANMESSAGE is TRUE, but no .message found in $GLROOT/$folders."
                  fi
                fi
              
                if [ "$1" != "test" ]; then
                  $NUKEPROG -r $GLCONF -N $NUKEUSER -n {$folders/$REALNAME} $INCOMMULTIPLIER -Auto- Not completed for $TIMEINCOM minutes.
                  echo "$DATENOW Nuke: $folders/$REALNAME - Incomplete after $TIMEINCOM minutes. $INCOMMULTIPLIER Nuke." >> $LOG
                  JUSTNUKED="$REALNAME"
                fi
                LAST="$REALNAME"
              else
                if [ "$1" = "test" ]; then
                  if [ "$SAIDIT" != "$REALNAME" ]; then
                    echo "$REALNAME is excluded".
                    SAIDIT="$REALNAME"
                  fi
                fi
              fi
                if [ "$CLEANSYMLINKS" = "TRUE" ]; then
                if [ "$1" != "test" ]; then
                  rm -rf $VERIFY
                  echo "$DATENOW Dele: Removing symlink $VERIFY" >> $LOG
                fi
                if [ "$1" = "test" ]; then
                  if [ "$SAIDIT2" != "$REALNAME" ]; then
                    echo "Removing symlink: $VERIFY (test)"
                    echo ""
                    SAIDIT2="$REALNAME"
                  fi
                fi
              fi
            fi
          done
          if [ "$PRENUKEINCOM" = "TRUE" ]; then
            if [ "$JUSTNUKED" != "$REALNAME" ]; then
              for folder in `find $REALNAME -type d -mmin +$EARLYINCOM -maxdepth 1 -print | grep -vw "$NUKES" | grep -vx $REALNAME | cut -b9-`; do
                if [ "$REALNAME" != "$LAST" ]; then
                  EXCLUDE="NO"
                  for excludes in $EXCLUDES; do
                    VERIFY2="$( echo $REALNAME | grep -i $excludes )"
                    if [ "$VERIFY2" != "" ]; then
                      EXCLUDE="YES"
                    fi
                  done  

                  if [ "$EXCLUDE" != "YES" ]; then
                    if [ "$1" = "test" ]; then
                      if [ -e "$TEMPDIR/prewarned.$REALNAME" ]; then
                        PREWARNING="TRUE"
                        if [ "$SAIDIT4" != "$REALNAME" ]; then
                          echo "$REALNAME is older then $EARLYINCOM minutes. Pre warning already sent though. (test)"
                          echo "  -Remove $TEMPDIR/prewarned.$REALNAME to send again."
                          SAIDIT4="$REALNAME"
                        fi
                      else
                        PREWARNING="TRUE"
                        if [ "$SAIDIT3" != "$REALNAME" ]; then
                          echo "$REALNAME is older then $EARLYINCOM minutes. Pre-Nuke warning. (test)."
                          echo "$REALNAME" > $TEMPDIR/prewarned.$REALNAME
                          SAIDIT3="$REALNAME"
                        fi
                      fi
                    else
                      if [ "$GLLOG" != "" ]; then
                        if [ -e "$TEMPDIR/prewarned.$REALNAME" ]; then
                          PREWARNING="TRUE"
                        else
                          PREWARNING="TRUE"
                          if [ "$SAIDIT3" != "$REALNAME" ]; then
                            echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $REALNAME\002 has not been completed within $EARLYINCOM minutes. Will be nuked when its \002$TIMEINCOM\002 minutes old." >> $GLLOG
                            echo "$REALNAME" > $TEMPDIR/prewarned.$REALNAME
                            if [ "$SAIDIT4" != "$REALNAME" ]; then
                              echo "$REALNAME is older then $EARLYINCOM minutes. Sending pre-nuke warning" >> $LOG
                              SAIDIT3="$REALNAME"
                            fi
                          fi
                        fi
                      fi
                    fi
                  fi
                fi
              done
            fi
          fi
        else
          if [ "$1" = "test" ]; then
            echo "$REALNAME does NOT exist anymore"
          fi
          if [ "$CLEANSYMLINKS" = "TRUE" ]; then
            if [ "$1" != "test" ]; then
              rm -rf $VERIFY
              echo "$DATENOW Dele: Removing symlink $VERIFY" >> $LOG
            fi
            if [ "$1" = "test" ]; then
              echo "Removing symlink to $VERIFY (test)"
            fi
          fi
        fi
      fi
    SAIDIT3=""
    SAIDIT4=""
    JUSTNUKED=""
    REALNAME=""
    done
  done
fi

####################################################################################
## Banned words module                                                             #
####################################################################################

if [ "$BANNEDWORDS" = "TRUE" ]; then
  ## Make a | between excluded folders.
  EXCLUDESPECIAL="$( echo $EXCLUDES | tr -s ' ' '|' )"
  if [ "$BANEXCLUDE" != "" ]; then
    BANEXCLUDE="$( echo $BANEXCLUDE | tr -s ' ' '|' )"
    EXCLUDESPECIAL="$EXCLUDESPECIAL|$NUKES|$BANEXCLUDE"
  else
    EXCLUDESPECIAL="$EXCLUDESPECIAL|$NUKES"
  fi

  if [ "$1" = "test" ]; then
    echo ""
    echo "-[ Checking banned-words folders ]-"
  fi

  for stuff in $BANDIRS; do
    folders="$( echo $stuff | awk -F"~" '{print $1}' )"
    BANWORD="$( echo $stuff | awk -F"~" '{print $2}' )"
    BANWORD="$( echo $BANWORD | tr -s ':' ' ' )"

    if [ "$1" = "test" ]; then
      echo "--Entering $folders. Banned words are $BANWORD"
    fi
   
    if [ -e $GLROOT$folders ]; then
      cd $GLROOT$folders
    else
      echo "I can not find $GLROOT$folders - I'll quit here while you fix your mistake."
      echo "Check the BANDIRS= settings."
      exit 0
    fi
 
    for them in `ls -L | egrep -iv $EXCLUDESPECIAL`; do
      #echo "Checking $them"
      for banword in $BANWORD; do
        VERIFY="$( echo $them | grep -i $banword )"
        #echo "Checking if $banword is in $them"
        if [ "$VERIFY" != "" ]; then
          #echo "$them contains a banned word!"
          for found in `find $GLROOT$folders/$them -type d -mmin +$TIMEBANNUKE -maxdepth 0 -print | grep -vw "$NUKES" | grep -vx $them | cut -b9-`; do
            ALLOW="$( find $GLROOT$folders/$them -type d -maxdepth 1 -print | grep -i $ALLOWED )"
            if [ "$ALLOW" = "" ]; then
              BANPROCESS="TRUE"
              if [ "$1" = "test" ]; then
                echo "$them ($banword) is older then $TIMEBANNUKE min. NUKE! (test)"
                BANLAST="$them"
              else
                $NUKEPROG -r $GLCONF -N $NUKEUSER -n {$folders/$them} $BANMULTIPLIER -Auto- $banword not allowed
                BANLAST="$them"
                echo "$DATENOW Nuke: $folders/$them - Contains $banword after $TIMEBANNUKE minutes. $BANMULTIPLIER Nuke." >> $LOG
              fi
            else
              if [ "$1" = "test" ]; then
                echo "$them ($banword) is older then $TIMEBANNUKE min, but it has been allowed."
              fi
              BANLAST="$them"
            fi
          done
          if [ "$BANLAST" != "$them" ]; then
            for found in `find $GLROOT$folders/$them -type d -mmin +$EARLYBANPRENUKE -maxdepth 0 -print | grep -vw "$NUKES" | grep -vx $them | cut -b9-`; do
              ALLOW="$( find $GLROOT$folders/$them -type d -maxdepth 1 -print | grep -i $ALLOWED )"
              if [ "$ALLOW" = "" ]; then
                BANPROCESS="TRUE"
                if [ "$1" = "test" ]; then
                  if [ -e $TEMPDIR/prewarnedbanned.$them ]; then
                    echo "$them ($banword) is older then $EARLYBANPRENUKE mins. Warning already sent. (test)"
                  else
                    echo "$them is older then $EARLYBANPRENUKE. Prenuke-warning (test)"
                    echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarnedbanned.$them 
                  fi
                else
                  if [ -e $TEMPDIR/prewarnedbanned.$them ]; then
                    CORE="yes"
                  else
                    if [ "$BANPRENUKE" = "TRUE" ]; then
                      echo "$(date +'%a %b %d %T %Y') $BOTTRIGGER \002-(AutoNuke)- $them\002 - $banword not allowed. Will be nuked when its \002$TIMEBANNUKE\002 minutes old." >> $GLLOG
                      echo "Tur-autonuke prewarning file" > $TEMPDIR/prewarnedbanned.$them 
                      echo "$DATENOW Nuke: $folders/$them contains $banword after $EARLYBANPRENUKE minutes. Pre-nuke warning sent." >> $LOG
                    fi
                  fi
                fi
              else
                if [ "$1" = "test" ]; then
                  echo "Would be pre warning time for $GLROOT$folders/$them, but its been allowed."
                fi
              fi
            done
          fi
          VERIFY=""
        fi
      done
    done
  done
fi



if [ "$PREWARNING" != "TRUE" ]; then
  rm -f $TEMPDIR/prewarned.*
fi

if [ "$EMPTYPROCESS" != "TRUE" ]; then
  rm -f $TEMPDIR/prewarnedempty.*
fi

if [ "$HALFPROCESS" != "TRUE" ]; then
  rm -f $TEMPDIR/prewarnedalmostempty.*
fi

if [ "$BANPROCESS" != "TRUE" ]; then
  rm -f $TEMPDIR/prewarnedbanned.*
fi

exit 0
